%%%%%% EM algorithm %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%Loop through all entries in the time list
%%% Mark them as lost, received or missed
%%% applying the backward and forward algorithm for a HSSM with two states
%%% and 3 possible observations

n_samples=length(trce);
%Special parameter fo the algorithm
timeInt=1;

%Infer lambda from trceTime
lambda=10;

D=4;
B=[1-exp(-lambda) 0 exp(-lambda);0 1-exp(-lambda) exp(-lambda)]; %%% 3 is unobserved; 1 is loss, 2 is good
%B=[1 0 1;0 1 1];

%Initialize parameter values
k=[1 1];
theta=[1 100];

binArray=[1 1 2 2 1 2 2 2 1 2];

T=length(binArray);

%%%% Forward and backward algotihm Algo
%%%% Build an array rhotd1, rhotd0 of size n+m
%%%%%

iterNr=0;

likelihood = -1;%log(sum(alpha(:,length(timeArray))));
likelihoodold=-10;

%%% stopping criteria
%while (abs(theta(1)-thetaold(1))>0.1)|| (abs(theta(2)-thetaold(2))>0.1)
%while (((likelihood-likelihoodold>0.001*abs(likelihoodold))&& (iterNr<40))||(iterNr==1))
while iterNr<10    
    tic
    iterNr=iterNr+1
    
    thetaold=theta;
    kold=k;
    
    likelihoodold=likelihood;
    
    %%%%%%%%%%%%%%%%%%%%%%%%%++foward++%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    disp('Forward Step');
    alpha=ones(2,T+1);
    
    alphans=ones(2,T+1);
    
    %%%Rho
    alpha(1,1)=0.5;
    alpha(2,1)=0.5;
    
    alphans(1,1)=0.5;
    alphans(2,1)=0.5;
    
    scaling =ones(1,T+1);
    
    for i=1:2
        for j=1:D
            P(i,j) =  distF(theta(i),k(i),j,lambda);
        end
    end
    
    
    for i=2:T+1
        alpha(1,i)= 0;
        alpha(2,i)= 0;
        
        alphans(1,i)= 0;
        alphans(2,i)= 0;
        
        %disp(['i: ', num2str(i)]);
        
          %%%%scaling

        if (binArray(i-1)>=0)&&(sum(alpha(:,i-1))>0)
            scaling(i-1) = 1/sum(alpha(:,i-1));
        end
        
        %alpha(1,i)
        for tau=1:min(D,i-1)                      
            alpha(1,i)=alpha(1,i)+alpha(2,i-tau)*P(1,tau)*prod(B(1,binArray(i-tau:i-1)))*prod(scaling(i-tau:i-1));
            alpha(2,i)=alpha(2,i)+alpha(1,i-tau)*P(2,tau)*prod(B(2,binArray(i-tau:i-1)))*prod(scaling(i-tau:i-1));
            
            alphans(1,i)=alphans(1,i)+alphans(2,i-tau)*P(1,tau)*prod(B(1,binArray(i-tau:i-1)));
            alphans(2,i)=alphans(2,i)+alphans(1,i-tau)*P(2,tau)*prod(B(2,binArray(i-tau:i-1)));
            
            %disp(['Tau: ',int2str(tau), ', P(1,tau):', num2str(P(1,tau)),', alpha(2,i-tau):',num2str(alpha(2,i-tau)), ', alpha(1,i):', num2str(alpha(1,i)), ', bin:', num2str(B(1,binArray(i-tau:i-1)))]);
            
            %disp(['Tau: ',int2str(tau), ', P(2,tau):', num2str(P(2,tau)),', alpha(1,i-tau):',num2str(alpha(1,i-tau)), ', alpha(2,i):', num2str(alpha(2,i)), ', bin:', num2str(B(2,binArray(i-tau:i-1)))]);
        end
        
    end
    
    %%%%%%%%%%%%%%%%%%%%%%%%%++backward++%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    disp('Backward Step');
    beta = ones(2,T+1);
    
    betans = ones(2,T+1);
    
    
    for i=2:T
        
        %disp(['i: ', num2str(i)]);
        
        iinv=T+1-i;
        
        beta(1,iinv)=0;
        beta(2,iinv)=0;
        
        betans(1,iinv)=0;
        betans(2,iinv)=0;
        
        for tau=1:min(T-iinv,D)
            beta(1,iinv) = beta(1,iinv)+P(2,tau)*prod(B(2,binArray(iinv+1:iinv+tau)))*beta(2,iinv+tau)*prod(scaling(iinv+1:iinv+tau));
            beta(2,iinv) = beta(2,iinv)+P(1,tau)*prod(B(1,binArray(iinv+1:iinv+tau)))*beta(1,iinv+tau)*prod(scaling(iinv+1:iinv+tau));
            
            betans(1,iinv) = betans(1,iinv)+P(2,tau)*prod(B(2,binArray(iinv+1:iinv+tau)))*betans(2,iinv+tau);
            betans(2,iinv) = betans(2,iinv)+P(1,tau)*prod(B(1,binArray(iinv+1:iinv+tau)))*betans(1,iinv+tau);
            
            
            %disp(['Tau: ',int2str(tau), ', iinv:', num2str(iinv),', beta(2,iinv+tau):',num2str(beta(2,iinv+tau)), ', beta(1,iinv):', num2str(beta(1,iinv)), ', bin:', num2str(B(2,binArray(iinv+1:iinv+tau)))]);
            %disp(['Tau: ',int2str(tau), ', iinv:', num2str(iinv),', beta(1,iinv+tau):',num2str(beta(1,iinv+tau)), ', beta(2,iinv):', num2str(beta(2,iinv)), ', bin:', num2str(B(1,binArray(iinv+1:iinv+tau)))]);
            
        end
        
    end
    
    %disp(alpha)
    %disp(beta)
    
    %+++++++++++++Update parameters ++++++++++++++++++++++++++++++%%
    disp('Update Parameters');
    k1array=[0.01:0.01:20];
    %%%k1array=[1];
    diffarray1=[];
    k2array=[0.01:0.01:20];
    %%%%k2array=[1];
    diffarray2=[]; 
    theta2array=[];
    theta1array=[];
    
    nume1=0;
    deno1=0;
    deno2=0;
    nume2=0;
    numek1=0;
    denok1=0;
    denok2=0;
    numek2=0;
    
    for i=2:T+1
        t=i-1;
        numeTau1=0;
        numeTau2=0;
        numekTau1=0;
        numekTau2=0;
        for tau=1:min(D,t)
            numeTau1=numeTau1+(tau)*alpha(2,i-tau)*P(1,tau)*prod(B(1,binArray(i-tau:i-1)))*beta(1,t)*prod(scaling(i-tau:i-1));
            numeTau2=numeTau2+(tau)*alpha(1,i-tau)*P(2,tau)*prod(B(2,binArray(i-tau:i-1)))*beta(2,t)*prod(scaling(i-tau:i-1));
            numekTau1=numekTau1+log(tau/theta(1))*alpha(2,i-tau)*P(1,tau)*prod(B(1,binArray(i-tau:i-1)))*beta(1,t)*prod(scaling(i-tau:i-1));
            numekTau2=numekTau2+ log(tau/theta(2))*alpha(1,i-tau)*P(2,tau)*prod(B(2,binArray(i-tau:i-1)))*beta(2,t)*prod(scaling(i-tau:i-1));
        end
        
        nume1=nume1+numeTau1;
        nume2=nume2+numeTau1;
        numek1=numek1+numekTau1;
        numek2=numek2+numekTau2;
        deno1=deno1+alpha(1,i)*beta(1,t);
        deno2=deno2+alpha(2,i)*beta(2,t);
        denok1=denok1+alpha(1,i)*beta(1,t);
        denok2=denok2+alpha(1,i)*beta(1,t);
    end
    
    
    toc
    
    %%%%%% Numercial search %%%%%%%%
    for kidx=1:length(k1array)
        k(1)=k1array(kidx);
        k(2)=k2array(kidx);
        %theta(1)= nume1/(k(1)*deno1);
        %theta(2)= nume2/(k(2)*deno2);
        diffarray1=[diffarray1 abs(numek1/denok1-psi(k(1)))];
        diffarray2=[diffarray2 abs(numek2/denok2-psi(k(2)))];
        
    end
    
    [mink1 k1]=min(diffarray1);
    k(1)=k1array(k1(1));
    
    [mink2 k2]=min(diffarray2);
    k(2)=k2array(k2(1));
    % %
    % %         %%%%%%% Newton Method %%%%%%%%
    % %             k(1) = timeInt*nume1/(theta(1)*deno1);
    % %             k(2) = timeInt*nume2/(theta(2)*deno2);
    % %             kold=[0 0];
    % %
    % %             while (abs(kold(1)-k(1))>0.1)
    % %                 kold(1) =k(1);
    % %                 k(1)= k(1) - (-numek1/denok1 + log(nume1/deno1)-log(k(1)) + psi(k(1)))/(psi(1,k(1))-1/k(1));
    % %             end
    % %
    % %             while (abs(kold(2)-k(2))>0.1)
    % %                 kold(2) =k(2);
    % %                 k(2)= k(2) - (-numek2/denok2  +log(nume2/deno2) -log(k(2))+psi(k(2)))/(psi(1,k(2))-1/k(2));
    % %             end
    
    theta(1)= nume1/(k(1)*deno1); %%%% CHECK CHECK CHECK !!!
    theta(2)= nume2/(k(2)*deno2);
    
    k
    theta
    
    likelihood = 0;
    lh1=0;
    lh2=0;
    for tau=1:D
        lh1=lh1+alpha(2,T+1-tau)*P(1,tau)*prod(B(1,binArray(T+1-tau:T)))*beta(1,T)*prod(scaling(T+1-tau:T));
        lh2=lh2+alpha(1,T+1-tau)*P(2,tau)*prod(B(2,binArray(T+1-tau:T)))*beta(2,T)*prod(scaling(T+1-tau:T));
    end
    likelihood = lh1 + lh2;
        
    loglikelihood= log(likelihood)-sum(log(scaling))
   
    
   
    loglikelihood= log(alpha(1,T+1) +alpha(2,T+1))-sum(log(scaling))
    %log(alpha(1,3) +alpha(2,3))-sum(log(scaling))
    %log(alpha(1,7) +alpha(2,7))-sum(log(scaling))
    
    %likelihood=-sum(log(scaling))
    toc
end
